/**
 *
 *  Class ConstraintDiagramsReaderAdapter.java
 *
 *  Generated by KMF [ToolGen] at 30 April 2003 10:26:36
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.repository.implementation;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import uk.ac.ukc.cs.kmf.ocl.IBoolean;
import uk.ac.ukc.cs.kmf.ocl.IInteger;
import uk.ac.ukc.cs.kmf.ocl.IMutableCollection;
import uk.ac.ukc.cs.kmf.ocl.IOclAny;
import uk.ac.ukc.cs.kmf.ocl.IReal;
import uk.ac.ukc.cs.kmf.ocl.IString;
import uk.ac.ukc.cs.kmf.ocl.IStringBuffer;
import uk.ac.ukc.cs.kmf.ocl.implementations.OCL;
import uk.ac.ukc.cs.kmf.xmi.FeatureInfo;
import uk.ac.ukc.cs.kmf.xmi.IReaderAdapter;
import uk.ac.ukc.cs.kmf.xmi.ObjectInfo;
import uk.ac.ukc.cs.kmf.xmi.ReaderAdapter;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.IConstraintDiagramsLifecycle;

/**
  * This class represents a reader adapter that can be used to load XMI files into the repository
  */
public class ConstraintDiagramsReaderAdapter
    extends ReaderAdapter
    implements IReaderAdapter
{
  /** The repository */
  ConstraintDiagramsRepository rep;

  /** Abstract factory */
  public ConstraintDiagramsReaderAdapter(ConstraintDiagramsRepository rep) {
    this.rep = rep;
  }

  /** 
    * This method is called everytime a CreateObject event appears during 
    * the XMI file parsing
    */
  public java.lang.Object createObject(ObjectInfo info) {
    // References to other objects is the XMI framework responsability
    if (info.getIdref() != null) return null;
    // Use the repository to create object
    else {
      String objName = info.getXMIName();
      rep.getLog().reportMessage("Loading an instance of '"+objName+"'");
      if (objName.endsWith("Lifecycle")) {
          try {
              int pos1 = objName.lastIndexOf(".");
              int pos2 = objName.lastIndexOf("Lifecycle");
              String lifecycleName = objName.substring(0, pos1)+".implementation"+objName.substring(pos1, objName.length());
              String indexName = objName.substring(0, pos2);
              Class cls = Class.forName(lifecycleName);
              Class type = Class.forName("ConstraintDiagrams.repository.IConstraintDiagramsRepository");
              Constructor cons = cls.getConstructor(new Class[] {type});
              IConstraintDiagramsLifecycle lifecycle = (IConstraintDiagramsLifecycle)cons.newInstance(new Object[] {rep});
              rep.addLifecycle(indexName, lifecycle);
              return lifecycle;
          } catch (Exception e) {
              rep.getLog().reportMessage("Class not found - '"+objName+"'");
              rep.getLog().reportMessage(""+e);
              return null;
          }
      }
      if (objName.equals("ISequence")) return OCL.Sequence();
      if (objName.equals("ISet")) return OCL.Set();
      if (objName.equals("IBag")) return OCL.Bag();
      if (objName.equals("IMutableSequence")) return OCL.MutableSequence();
      if (objName.equals("IMutableSet")) return OCL.MutableSet();
      if (objName.equals("IMutableBag")) return OCL.MutableBag();
      return rep.buildElement(objName);
   }
  }

  /** 
    * This method is called everytime a CreateProperty event appears
    * during XMI parsing
    */
  public java.lang.Object createProperty(FeatureInfo info) {
    // Set the property
    if (info.getValue() == null) return info.getXMIName();
    String message = "\tCreate property '"+info.getXMIName()+"' into '"+info.getObject()+"' with value '"+info.getValue()+"'";
    setPropertyValue(info.getObject(), info.getXMIName(), info.getValue());
    return null;
  }

  /** 
    * This method is called everytime a ResolveValue event appears
    * during XMI parsing
    */
  public void resolveValue(java.lang.Object object, java.lang.Object property, java.lang.Object value) {
    // Set property
    String message = "Resolve property '"+property+"' from '"+object+"' to '"+value+"'";
    setPropertyValue(object, (String)property, value);
  }

  /** 
    * This method is called everytime a SetProperty event appears
    * during XMI parsing
    */
  public void setPropertyValue(Object object, String name, Object value) {
    // Get the name of the class
    if (name.indexOf(".")!=-1) name = name.substring(name.lastIndexOf(".")+1,name.length());
    // Get the object's method corresponding to property
    // Get also return type
    Class type=null;
    Method property=null;
    try {
      property = object.getClass().getMethod(name, new Class[] {});
      type = property.getReturnType();
    } catch (Exception e) {
      rep.getLog().reportMessage("Cannot find property '"+name+"'");
      rep.getLog().reportMessage(""+e);
    }
    // Set the property to the specific value
    String mutatorName = "set"+name.substring(0,1).toUpperCase()+name.substring(1,name.length());
    try {
      // Return type is a StringBuffer
      if (type == IStringBuffer.class) {
	     ((IStringBuffer)property.invoke(object,new Object[]{})).setTo(getStr((String)value));
      // Return type is a String
      } else if (type == IString.class) {
        ((IStringBuffer)property.invoke(object,new Object[]{})).setTo(getStr((String)value));
      // Collection
      } else if (IMutableCollection.class.isAssignableFrom(type)) {
        ((IMutableCollection)property.invoke(object, new Object[]{})).add((IOclAny)value);
      // Other return type
      } else {
        // Get the set method
        Method mutator = object.getClass().getMethod(mutatorName, new Class[] {type});
        // Return type is Boolean
        if (type == IBoolean.class) {
          mutator.invoke(object, new Object[]{OCL.Boolean( ((String)value).equals("true") ? true : false )});
        // Return type is Integer
        } else if (type == IInteger.class) {
          mutator.invoke(object, new Object[]{OCL.Integer(Integer.parseInt((String)value))});
        // Return type is Real
        } else if (type == IReal.class) {
          mutator.invoke(object, new Object[]{OCL.Real(Double.parseDouble((String)value))});
        } else {
          mutator.invoke(object, new Object[]{value});
        }
      }
    } catch (Exception e) {
      String message = "Cannot invoke mutator '"+mutatorName+"("+type+")'\n";
      message += "this = "+object+"\n";
      message += "argument = '"+value.getClass()+"("+value+")";
      rep.getLog().reportMessage(message);
      rep.getLog().reportMessage(""+e);
    }
  }
    	String getStr(String s) {
    		int first = 0;
    		int last = s.length()-1;
    		if ( s.charAt(first) == '\'' && s.charAt(last) == '\'' ) {
    			return s.substring(first+1, last);
    		} else {
    			return s;
    		}
    	}
}
