/*
 * LittleLibrary.java
 *
 * Created on 17 October 2002
 *
 * Test for interchange with EMF
 */

package startup;

import uk.ac.ukc.cs.kmf.studio.vsml.repository.VsmlBrowser$Class;
import uk.ac.ukc.cs.kmf.studio.vsml.repository.VsmlRepository$Class;

/**
 *
 * @author  sjhk
 */
public class LittleLibrary {
    
    /** LittleLibrary test example */
    public LittleLibrary() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) { 
        //create repository
        VsmlRepository$Class rep = new VsmlRepository$Class();
        String ASpath = "uk.ac.ukc.cs.kmf.studio.vsml.AS.";
        String SDpath = "uk.ac.ukc.cs.kmf.studio.vsml.SD.";
        String Sempath = "uk.ac.ukc.cs.kmf.studio.vsml.Semantics.";
        System.out.println("Repository created.");
        
        //replace default builders with own
        //AS builders
        rep.registerFactory(ASpath+"Association", new lifecycle.AssociationLifecycle(rep));
        rep.registerFactory(ASpath+"AssociationEnd", new lifecycle.AssociationEndLifecycle(rep));
        rep.registerFactory(ASpath+"Class_", new lifecycle.Class_Lifecycle(rep));
        rep.registerFactory(ASpath+"Package_", new lifecycle.Package_Lifecycle(rep));  
                        
        //get required builders from repository
        //AS builders
        lifecycle.Class_Lifecycle class_b = (lifecycle.Class_Lifecycle)(rep.getFactory(ASpath+"Class_"));
        lifecycle.AssociationLifecycle assoc_b = (lifecycle.AssociationLifecycle)(rep.getFactory(ASpath+"Association"));
        lifecycle.Package_Lifecycle package_b = (lifecycle.Package_Lifecycle)(rep.getFactory(ASpath+"Package_"));
        System.out.println("Builders extracted.");

        //CREATE LittleLibrary
        //create package
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ p_Library = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)package_b.build();
        p_Library.setName("Library");
        System.out.println("Built all packages.");
        
        //create classes and add to package
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_System = class_b.build(p_Library, "System");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_Copy = class_b.build(p_Library, "Copy");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_Publication = class_b.build(p_Library, "Publication");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_Loan = class_b.build(p_Library, "Loan");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_Reservation = class_b.build(p_Library, "Reservation");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_User = class_b.build(p_Library, "User");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_Boolean = class_b.build(p_Library, "Boolean");
        uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ c_String = class_b.build(p_Library, "String");
        System.out.println("Built all classes.");
        
        //create binary associations
        assoc_b.build(
			p_Library, c_System, c_Publication, 
			"publication", new Integer(0), new Integer(0), 
			"system", new Integer(1), new Integer(1)
        );
        assoc_b.build(
            p_Library, c_System, c_User, 
            "user", new Integer(0), new Integer(0), 
            "system", new Integer(1), new Integer(1)
        );
        assoc_b.build(
            p_Library, c_Copy, c_Publication, 
            "publication", new Integer(1), new Integer(1),
            "copy", new Integer(0), new Integer(0)
        );
        assoc_b.build(
            p_Library, c_Loan, c_Copy, 
            "copy", new Integer(1), new Integer(1),
            "loan", new Integer(0), new Integer(0)
        );        
        assoc_b.build(
            p_Library, c_Loan, c_User,
            "user", new Integer(1), new Integer(1), 
            "loan", new Integer(0), new Integer(0)
        );
        System.out.println("Built all binary associations.");
            
        //create unary associations
        assoc_b.build(
            p_Library, c_User, c_String, 
            "name", new Integer(1), new Integer(1));        
        assoc_b.build(
            p_Library, c_Publication, c_String, 
            "title", new Integer(1), new Integer(1));
        assoc_b.build(
            p_Library, c_Copy, c_Loan, 
            "currentLoan", new Integer(0), new Integer(1));
        System.out.println("Built all unary associations.");
        
        VsmlBrowser$Class browser = new VsmlBrowser$Class("../VsmlModel/vsml.xmi");
        browser.setRep(rep);
        browser.show();
    }
    
}
