/**
 *
 *  Class VsmlParseAllVisitor.java
 *
 *  Generated by KMFStudio at 03 December 2003 16:13:47
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.kmf.studio.vsml;

import java.util.*;

import uk.ac.kent.cs.kmf.util.*;
import uk.ac.kent.cs.ocl20.syntax.ast.contexts.*;
import uk.ac.kent.cs.ocl20.syntax.parser.*;

public class VsmlParseAllVisitor$Class
	extends VsmlVisitor$Class
	implements VsmlParseAllVisitor
{
	// Create an OCL parser
	protected OclParser oclParser = new OclParserImpl();
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ host, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		int errorNo;
		PackageDeclarationAS pkgDeclAS;
		log.reportMessage("Parsing invariants for "+host+"...");
		try {
			errorNo = log.getErrors();
			//--- Print invariant ---
			invariant = "context vsml::AS::Class_ inv targetOf_size: 0<=targetOf->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Class_ inv targetOf_bidirectional: targetOf->forAll(x | x.target=self)";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Class_ inv superClass_size: 0<=superClass->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Class_ inv sourceOf_size: 0<=sourceOf->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Class_ inv sourceOf_bidirectional: sourceOf->forAll(x | x.source=self)";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Class_ inv owner_bidirectional: Set{owner}->forAll(x | x.class_->includes(self))";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::Class_ inv names_of_assoc_ends_are_unique : sourceOf . name -> asSet() -> asBag() = sourceOf . name";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			if (errorNo == log.getErrors()) {
			log.reportMessage("No errors");
			}
		} catch (Exception e1) {
			log.reportError("Runtime error: ", e1);
			e1.printStackTrace(System.out);
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ host, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		int errorNo;
		PackageDeclarationAS pkgDeclAS;
		log.reportMessage("Parsing invariants for "+host+"...");
		try {
			errorNo = log.getErrors();
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv owner_bidirectional: Set{owner}->forAll(x | x.package_->includes(self))";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv package__size: 0<=package_->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv package__bidirectional: package_->forAll(x | x.owner=self)";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv association_size: 0<=association->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv association_bidirectional: association->forAll(x | x.owner=self)";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv class__size: 0<=class_->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Package_ inv class__bidirectional: class_->forAll(x | x.owner=self)";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class_names_unique : class_ . name -> asSet() -> asBag() = class_ . name";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package_names_unique : package_ . name -> asSet() -> asBag() = package_ . name";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::Package_ inv assoc_names_unique : association . name -> asSet() -> asBag() = association . name";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			if (errorNo == log.getErrors()) {
			log.reportMessage("No errors");
			}
		} catch (Exception e1) {
			log.reportError("Runtime error: ", e1);
			e1.printStackTrace(System.out);
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Association' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Association host, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		int errorNo;
		PackageDeclarationAS pkgDeclAS;
		log.reportMessage("Parsing invariants for "+host+"...");
		try {
			errorNo = log.getErrors();
			//--- Print invariant ---
			invariant = "context vsml::AS::Association inv owner_bidirectional: Set{owner}->forAll(x | x.association->includes(self))";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Association inv associationEnd_size: 1<=associationEnd->size()";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::Association inv associationEnd_bidirectional: associationEnd->forAll(x | x.owner=self)";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::Association inv one_at_other_of_two_and_vice_versa : associationEnd -> size() = 1 or ( associationEnd -> size() = 2 and associationEnd -> first() . otherEnd = associationEnd -> last() and associationEnd -> last() . otherEnd = associationEnd -> first() )";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			if (errorNo == log.getErrors()) {
			log.reportMessage("No errors");
			}
		} catch (Exception e1) {
			log.reportError("Runtime error: ", e1);
			e1.printStackTrace(System.out);
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd host, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		int errorNo;
		PackageDeclarationAS pkgDeclAS;
		log.reportMessage("Parsing invariants for "+host+"...");
		try {
			errorNo = log.getErrors();
			//--- Print invariant ---
			invariant = "context vsml::AS::AssociationEnd inv target_bidirectional: Set{target}->forAll(x | x.targetOf->includes(self))";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::AssociationEnd inv owner_bidirectional: Set{owner}->forAll(x | x.associationEnd->includes(self))";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context vsml::AS::AssociationEnd inv source_bidirectional: Set{source}->forAll(x | x.sourceOf->includes(self))";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv otherEnd_source_is_target : otherEnd -> isEmpty() or ( otherEnd . target = source and otherEnd . source = target )";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv upper_greater_than_lower : upper -> isEmpty() or upper >= lower";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv otherEnd_owner_is_owner_and_not_self : otherEnd -> isEmpty() or ( otherEnd . owner = owner and not ( otherEnd = self ) )";
			log.reportMessage(invariant);
			pkgDeclAS = oclParser.parse(invariant, log);
			if (pkgDeclAS == null) errorNo--;
			if (errorNo == log.getErrors()) {
			log.reportMessage("No errors");
			}
		} catch (Exception e1) {
			log.reportError("Runtime error: ", e1);
			e1.printStackTrace(System.out);
		}
		return null;
	}
}
